<script lang="ts">
    import { metatags, goto } from '@roxi/routify';
    import { onMount } from 'svelte';
    import axios from 'axios';
    import { PublicKey } from '../classes/storage/public-key';
    import { SecretKey } from '../classes/storage/secret-key';
    import { IWalletRequestElements, Utils } from '../classes/utils';
    import { Toast } from '../classes/toast';

    metatags.title = 'Settings';
    metatags.description = 'Description coming soon...';

    enum TokenStatus {
        idle,
        loading,
        success,
        danger
    }

    let checkingPkStatus: TokenStatus = TokenStatus.idle;
    let checkingSkStatus: TokenStatus = TokenStatus.idle;
    let userId: string = null;
    let pk: string = PublicKey.get() || '';
    let sk: string = SecretKey.get() || '';

    onMount(() => {
        if (pk) {
            Utils.getWalletRequestElements()
                .then((elements: IWalletRequestElements) => axios.post('/api/user', {pk: elements.pk, qs: elements.qs, signature: elements.signature}))
                .then(xhr => {
                    userId = xhr.data;
                });
        }
    });

    function onFormSubmit() {
        checkingPkStatus = TokenStatus.loading;
        checkingSkStatus = TokenStatus.loading;

        Utils.getWalletRequestElements(pk, sk)
            .then((elements: IWalletRequestElements) => {
                return axios.post('/api/token', {pk: elements.pk, signature: elements.signature, qs: elements.qs})
                    .then(xhr => {
                        PublicKey.set(pk);
                        SecretKey.set(sk);
                        checkingPkStatus = TokenStatus.success;
                        userId = xhr.data.user;
                        Toast.success('Your account has been created');
                        $goto('/send/user');
                    })
                    .catch(err => {
                        checkingPkStatus = TokenStatus.danger;
                        checkingSkStatus = TokenStatus.danger;
                        Toast.failure('An error occured: ' + err.toString());
                    });
            });
    }
</script>

<div>
    <h1 class="title has-text-centered">Settings</h1>
    {#if (userId)}
        <h2 class="subtitle">Your ID : {userId}</h2>
    {/if}
    <div>
        <form on:submit|preventDefault={() => onFormSubmit()}>

            <div class="field">
                <label class="label" for="token">Binance Public Key</label>
                <div id="token" class="control" class:has-icons-right={checkingPkStatus !== TokenStatus.loading} class:is-loading={checkingPkStatus === TokenStatus.loading}>
                    <input class="input" class:is-success={checkingPkStatus === TokenStatus.success} class:is-danger={checkingPkStatus === TokenStatus.danger} type="text" placeholder="Binance Public Key" bind:value={pk}>
                    <span class="icon is-small is-right">
                        {#if checkingPkStatus === TokenStatus.success}
                            <i class="fas fa-check"></i>
                        {/if}
                        {#if checkingPkStatus === TokenStatus.danger}
                            <i class="fas fa-exclamation-triangle"></i>
                        {/if}
                    </span>
                </div>
                {#if (checkingPkStatus === TokenStatus.success)}
                    <p class="help is-success" >This key is ok</p>
                {/if}
                {#if (checkingPkStatus === TokenStatus.danger)}
                    <p class="help is-danger" >This key is not ok</p>
                {/if}
            </div>

            <div class="field">
                <label class="label" for="sk">Binance Secret Key</label>
                <div id="sk" class="control" class:has-icons-right={checkingSkStatus !== TokenStatus.loading} class:is-loading={checkingSkStatus === TokenStatus.loading}>
                    <input class="input" class:is-success={checkingSkStatus === TokenStatus.success} class:is-danger={checkingSkStatus === TokenStatus.danger} type="text" placeholder="Binance Secret Key" bind:value={sk}>
                    <span class="icon is-small is-right">
                        {#if checkingSkStatus === TokenStatus.success}
                            <i class="fas fa-check"></i>
                        {/if}
                        {#if checkingSkStatus === TokenStatus.danger}
                            <i class="fas fa-exclamation-triangle"></i>
                        {/if}
                    </span>
                </div>
                {#if (checkingSkStatus === TokenStatus.success)}
                    <p class="help is-success" >This key is ok</p>
                {/if}
                {#if (checkingSkStatus === TokenStatus.danger)}
                    <p class="help is-danger" >This key is not ok</p>
                {/if}
            </div>

            <button class="button is-primary">Validate</button>

        </form>
    </div>
</div>
